//#include "stdafx.h"
#include "common.h"

using namespace System;

namespace cmmn {

	int n_comp, NCatVar;
	int * nCatPerVar;
	int NCases, MNVar;
	int ** X;
	double *** G, *** W, ** Lambda, *** Gw, ** Z, ** C, ** S;
	int * nweight;
	int TCat;
	double cor, cor2;

    double * XCoord, * YCoord;


	void CalcWeights( StreamWriter ^ fout, double ** G, int ncases, int p, int & nweight, double ** W, double * Lambda, double ** Gw ){
		double * f = new double[p];
		for (int i = 0; i < p; i++){
			f[i] = 0.0;
			for (int j = 0; j < ncases; j++)
				f[i] += G[j][i];
		}
		double ** G_m;
		G_m = new double*[ncases];
		for (int i = 0; i < ncases; i++){
			G_m[i] = new double[p];
			for (int j = 0; j < p; j++)
				G_m[i][j] = G[i][j] - f[j] / double(ncases);
		}

		myMat DGpGD(p, p);
		for (int i = 0; i < p; i++)
			for (int j = i; j < p; j++){
				double v = 0.0;
				for (int h = 0; h < ncases; h++)
					v += G_m[h][i] * G_m[h][j];
				DGpGD[i][j] = DGpGD[j][i] = v;
			}
			/***
			for (int i = 0; i < p; i++){
				for (int j = 0; j < p; j++)
					fout->Write(DGpGD[i][j].ToString("F3")->PadLeft(10));
				fout->WriteLine();
			}
			***/

		QL_decom ql;
		myMat aa(p, p), EigenVec(p, p), EigenVal(p, 1);
		int n_eigen;
		aa = DGpGD;
		ql.DoQL( aa, EigenVec, EigenVal, n_eigen );
		nweight = n_eigen;
		for (int i = 0; i < p; i++)
			Lambda[i] = EigenVal[i][0];

		fout->WriteLine("Lambda...");
		for (int i = 0; i < nweight; i++)
			fout->Write(Lambda[i].ToString()->PadLeft(20));
		fout->WriteLine();
		fout->WriteLine("Omega...");
		for (int i = 0; i < p; i++){
			if (i < nweight){
				for (int j = 0; j < p; j++)
					W[j][i] = EigenVec[j][i];
			}else{
				for (int j = 0; j < p; j++)
					W[j][i] = 0.0;
			}
		}

		for (int i = 0; i < ncases; i++){
			for (int j = 0; j < p; j++){
				if (j < nweight){
					double v = 0.0;
					for (int h = 0; h < p; h++)
						v += G_m[i][h] * W[h][j];
					Gw[i][j] = v;
				}else{
					Gw[i][j] = 0.0;
				}
			}
		}

		for (int j = 0; j < p; j++){
			for (int i = 0; i < nweight; i++)
				fout->Write(W[j][i].ToString("F3")->PadLeft(20));
			fout->WriteLine();
		}
		/***
		fout->WriteLine();
		for (int i = 0; i < ncases; i++){
			for (int j = 0; j < p; j++)
				fout->Write(Gw[i][j].ToString("F3")->PadLeft(10));
			fout->WriteLine();
		}
		***/

		for (int i = 0; i < ncases; i++)
			delete [] G_m[i];
		delete [] G_m;
	}
	
	bool operator > ( XstdValue & a, XstdValue & b ){
		bool v = false;
		if(a.value > b.value){
			v = true;
		}else if(a.value == b.value){
			if (a.j > b.j){
				v = true;
			}else if(a.j == b.j){
				if (a.k > b.k){
					v = true;
				}
			}
		}

		return v;
	}

	
	bool operator < ( XstdValue & a, XstdValue & b ){
		bool v = false;
		if(a.value < b.value){
			v = true;
		}else if(a.value == b.value){
			if (a.j < b.j){
				v = true;
			}else if(a.j == b.j){
				if (a.k < b.k){
					v = true;
				}
			}
		}

		return v;
	}
	
	XstdValue & XstdValue::operator = ( XstdValue & a ){
		value = a.value;
		j = a.j;
		k = a.k;
		return *this;
	}

	inline double sqr( double v ){
			return v * v;
	}
		
	double CalcCor( int n, double * x, double * y ){
		double sumx = 0.0, sumy = 0.0;
		for (int i = 0; i < n; i++){
			sumx += x[i];
			sumy += y[i];
		}
		double meanx = sumx / n;
		double meany = sumy / n;
		double sumxy = 0.0, sumxx = 0.0, sumyy = 0.0;
		for (int i = 0; i < n; i++){
			sumxy += (x[i] - meanx) * (y[i] - meany);
			sumxx += sqr(x[i] - meanx);
			sumyy += sqr(y[i] - meany);
		}
		return sumxy / Math::Sqrt(sumxx * sumyy);
	}
	
}
