#ifndef CMMN_CK
#define CMMN_CK
#include "mymat.h"
#include "myEigen.h"

using namespace System;
using namespace System::IO;
using namespace myLib;

namespace cmmn {


	extern int n_comp, NCatVar;
	extern int * nCatPerVar;
	extern int NCases, MNVar;
	extern int ** X;
	extern double *** G, *** W, ** Lambda, *** Gw, ** Z, ** C, ** S;
	extern int * nweight;

	extern int TCat;

	extern double cor, cor2;
    
    extern double * XCoord, * YCoord;

	using System::IO::StreamWriter;
	void CalcWeights( StreamWriter ^ fout, double ** G, int ncases, int p, int & nweight, double ** W, double * Lambda, double ** Gw );


	class XstdValue {
	public:
		double value;
		int j, k;
		XstdValue(){ }
		friend bool operator > ( XstdValue & a, XstdValue & b );
		friend bool operator < ( XstdValue & a, XstdValue & b );
		XstdValue & operator = ( XstdValue & a );
	};

	//
	//								Quick Sort
	//
	//      S. Kawai (1988).  Methods of programming (in Japanese). Tokyo: Iwanami-shoten.
	//		S. Ishihata (1989). Algorithms and Data Structure (in Japanese). Tokyo:Iwanami-shoten
	//
	template <class T> void qSort( T * d, int Lb, int Ub ){
		if (Lb < Ub){
			int p = (Lb + Ub) / 2;
			T c = d[p];
			int i = Lb;
			int j = Ub;
			do {
				while (d[i] < c) i++;
				while (c < d[j]) j--;
				if (i <= j){
					T v = d[i];
					d[i] = d[j];
					d[j] = v;
					i++;
					j--;
				}
			} while (i <= j);
			qSort(d, Lb, j);
			qSort(d, i, Ub);
		}
		return;
	}

	double CalcCor( int n, double * x, double * y );
}

#endif
